/* 
  SZARP: SCADA software 
  

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/
#ifndef _SSUTIL_H_
#define _SSUTIL_H_

#include <openssl/ssl.h>

#include "string.h"
#include "liblog.h"

#ifndef MINGW32
/**Inits liblog
 * @param argc number of command line params
 * @param argv array of command line params
 * @param name of currently running program
 * @return true if operation suceedes*/
bool InitLogging(int *argc, char **argv, const char* progname);
#endif


/**Does all stuff needed to initialize OpenSSL*/
void InitSSL();

/**PassphraseCallback used to gain access to private key,
 * copies at most size bytes from userdata to buff, buf is terminated by NULL
 * @param buf buffer to copy userdata to
 * @param size size of buf
 * @param rwflag not used
 * @param userdata passphrase
 * @return length of string stored in buf*/
int PassphraseCallback(char *buf, int size, int rwflag, void *userdata);

#endif
